XXD(1)

NOM
xxd - convertit en représentation hexadécimale et inversement.

SYNOPSIS
xxd -h[elp]
xxd [options] [fichier_entree [fichier_sortie]]
xxd -r[evert] [options] [fichier_entree [fichier_sortie]]

DESCRIPTION
xxd crée un fichier contenant la représentation hexadécimale d'un fichier binaire ou de l'entrée standard. Il peut également convertir un fichier de codes hexadécimaux en un fichier binaire. Comme uuencode(1) et uudecode(1) il permet la transmission de données binaires dans une représentation ASCII compatible avec le courrier électronique, mais a l'avantage de décoder la sortie standard. De plus, il peut être utilisé pour appliquer des rustines à des fichiers binaires.

OPTIONS
Si aucun fichier_entree n'est spécifié, l'entrée standard est utilisée. Si fichier_entree correspond au caractère '-' l'entrée standard est employée comme source des données en entrée. Si aucun fichier_sortie n'est spécifié (ou qu'un caractère '-' est donné à sa place), le résultat est envoyé sur la sortie standard.

NOTE : un analyseur paresseux est utilisé. Il ne vérifie pas au-delà de la première lettre de l'option, à moins que cette dernière ne requiert un paramètre. L'espace entre l'option et son paramètre est optionnel. Les paramètres des options peuvent être spécifiés en notation décimale, hexadécimale ou octale. Ainsi -c8, -c 8, -c 010 et -cols 8 sont tous équivalents.

-a | -autoskip
    active la fonctionnalité "autoskip" : le caractère '*' remplace les lignes d'octets nuls. Désactivée par défaut.

-b | -bits
    Convertit en binaires plutôt qu'en hexadécimal. Cette option écrit les octets comme une séquence de "1" et de "0" au lieu d'une conversion en hexadécimal traditionnel. Chaque ligne est précédée par un numéro de ligne en hexadécimal et suivie de la représentation ASCII (ou EBCDIC) correspondante. Les options -p, -i ne fonctionnent pas dans ce mode.

-c cols | -cols cols
    place <cols> octets par ligne. 16 par défaut (-i : 12, -ps : 30, -b : 6). Maximum 256.

-E | -EBCDIC
    Passe le codage des caractères de la colonne de droite de ASCII à EBCDIC. Cela ne change pas la représentation hexadécimale. Cette option est sans effet quand elle est utilisée avec -r, -p or -i.

-g octets | -groupsize octets
    Regroupe les octets (deux chiffres hexadécimaux ou huit chiffres binaires) par groupe de <octets> séparés par des espaces blancs. Spécifiez -g 0 pour supprimer le regroupement. <octets> vaut 2 par défaut dans le mode normal et 1 en représentation binaire. Le regroupement ne s'applique pas aux styles Postscript et Include.

-h | -help
    Affiche un résumé des commandes disponibles et quitte. Aucune conversion n'est effectuée.

-i | -include
    produit une sortie dans le style #include (fichier C à inclure). La définition complète d'un tableau statique est écrite et est nommée d'après le fichier d'origine, à moins que xxd lise depuis l'entrée standard.

-l long | -len long
    Arrête après l'écriture de <long> octets.

-p | -ps | -postscript | -plain
    Produit une conversion continue dans le style Postscript (postscript continuous hexdump style). Également connu sous le nom de « conversion brute » (plain hexdump style).

-r | -revert
    Opération inverse : convertit un fichier hexadécimal en un fichier binaire (ou applique une rustine à un fichier binaire). Si l'écriture n'a pas lieu sur la sortie standard, xxd écrit dans le fichier qu'il produit sans le tronquer. Utilisez la combinaison -r -p pour lire de l'hexadécimal brut sans information sur le numéro des lignes et sans format de colonnes particulier. Des espaces blancs et coupures de lignes supplémentaires sont autorisés à n'importe quel endroit.

-seek décalage
    Utilisé après l'option -r: inverse la conversion en ajoutant <décalage> aux positions dans le fichier données dans le code hexadécimal.

-s [+][-]décalage
    Débute au <décalage> absolu ou relatif dans fichier_entree. + indique que le décalage est relatif à la position courante dans l'entrée standard (sans effet si la lecture n'a pas lieu sur l'entrée standard). - indique un décalage en caractères depuis la fin de l'entrée (utilisé avec +, désigne la position avant la position actuelle de l'entrée standard). Sans l'option -s, xxd démarre à la position courante du fichier.

-u  Utilise des chiffres hexadécimaux majuscules. La casse par défaut est minuscule.

-v | -version
    Affiche la version de xxd.

MISE EN GARDE
xxd -r effectue des opérations internes un peu obscures lors de l'évaluation des informations sur les numéros de lignes. Si le fichier de sortie est adressable, alors les numéros de lignes au début de chaque ligne d'hexadécimal peuvent être désordonnées, des lignes peuvent manquer ou se chevaucher. Dans ces cas, xxd utilisera lseek(2) pour déterminer la prochaine position. Si le fichier n'est pas adressable, seuls les vides sont autorisés, et ils seront comblés par des octets nuls.

xxd -r ne génère aucune erreur lors de l'analyse. Les problèmes sont passés silencieusement.

Lors de l'édition de la représentation hexadécimale, veuillez noter que xxd -r ignore tout ce qui se trouve sur la ligne après avoir lu suffisamment de données hexadécimales (voir l'option -c). Cela signifie également que les modifications dans la colonne ASCII (ou EBCDIC) sont toujours ignorées. La conversion inverse de données hexadécimales brutes (postscript) avec xxd -r -p ne dépend pas d'un nombre correct de colonnes. Dans ce cas, tout ce qui ressemble à une paire de chiffres hexadécimaux est interprété.

Remarquez la différence entre
% xxd -i fichier
et
% xxd -i < fichier

xxd -s +seek peut différer de xxd -s seek, car lseek(2) est utilisé pour « revenir en arrière ». Le '+' fait une différence quand la source des données est l'entrée standard et si la position dans le fichier de l'entrée standard n'est pas au début du fichier lorsque xxd est démarré et qu'il reçoit ses données. L'exemple suivant peut vous aider à comprendre (ou bien vous perdre davantage encore !)...

Remettre l'entrée standard au départ avant de lire ; nécessaire car 'cat' a déjà lu jusqu'à la fin de l'entrée standard.
% sh -c 'cat > donnees_binaires; xxd -s 0 > donnees_hexa' < fichier

Convertir à partir de la position 0x480 (= 1024 + 128) du fichier. Le symbole '+' signifie "relativement à la position actuelle', ainsi 128 est ajouté aux 1024 octets comptabilisés pour dd.
% sh -c 'dd of=donnees_binaires bs=1k count=1; xxd -s +128 > donnees_hexa' < fichier

Convertir de fichier depuis la position 0x100 (= 1024 - 768) du fichier.
% sh -c 'dd of=donnees_binaires bs=1k count=1; xxd -s +-768 > donnees_hexa' < fichier

Toutefois, cette situation est peu fréquente et l'utilisation de '+' est rarement requise. L'auteur préfère surveiller les effets de xxd avec strace(1) ou truss(1) quand -s est employé.

EXEMPLES
Afficher la totalité du fichier sauf les trois premières lignes (0x30 octets en hexadécimal).
% xxd -s 0x30 fichier

afficher les trois dernières lignes (0x30 octets en hexadécimal) du fichier .
% xxd -s -0x30 fichier

Afficher 120 octets convertis en continu, avec 20 octets par ligne.
% xxd -l 120 -ps -c 20 xxd-fr.1
2e54482058584420312022616ffb742031393936
22202250616765206465206d616e75656c20706f
757220787864220a2e5c220a2e5c222032317374
204d617920313939360a2e5c22204d616e207061
676520617574686f723a0a2e5c2220202020546f
6e79204e7567656e74203c746f6e79407363746e
204e7567656e74203c746f6e79407363746e7567
2e54482058584420312022417567757374203139

Convertir les 120 premiers octets de cette page de manuel avec 12 octets par ligne.
% xxd -l 120 -c 12 xxd-fr.1
0000000: 2e54 4820 5858 4420 3120 2261 .TH XXD 1 "a
000000c: 6ffb 7420 3139 3936 2220 2250 o.t 1996" "P
0000018: 6167 6520 6465 206d 616e 7565 age de manue
0000024: 6c20 706f 7572 2078 7864 220a l pour xxd".
0000030: 2e5c 220a 2e5c 2220 3231 7374 .
000003c: 204d 6179 2031 3939 360a 2e5c May 1996..\
0000048: 2220 4d61 6e20 7061 6765 2061 " Man page a
0000054: 7574 686f 723a 0a2e 5c22 2020 uthor:..
0000060: 2020 546f 6e79 204e 7567 656e Tony Nugen
000006c: 7420 3c74 6f6e 7940 7363 746e t <tony@sctn

Afficher la date écrite au début du fichier xxd-fr.1.
% xxd -s 0x38 -l 13 -c 13 xxd.1
0000036: 3231 7374 204d 6179 2031 3939 36 21st May 1996

Copier fichier_entree vers fichier_sortie en ajoutant 100 octets de valeur 0x00 avant.
% xxd fichier_entree | xxd -r -s 100 > fichier_sortie

Patcher la date dans le fichier xxd.1
% echo '0000037: 3574 68' | xxd -r - xxd-fr.1
% xxd -s 0x38 -l 13 -c 13 xxd-fr.1
0000036: 3235 7468 204d 6179 2031 3939 36 25th May 1996

Créer un fichier de 65537 octets tous nuls (0x00), sauf le dernier qui vaut 'A' (0x41 en hexadécimal).
% echo '010000: 41' | xxd -r > fichier

Convertir le fichier de l'exemple précédent avec la fonctionnalité "autoskip".
% xxd -a -c 12 fichier
0000000: 0000 0000 0000 0000 0000 0000 ............
*
000fffc: 0000 0000 40 ....A

Créer un fichier d'un octet, contenant seulement le caractère 'A'. Le nombre après '-r -s' s'ajoute aux numéros de lignes trouvées dans le fichier ; les octets initiaux sont supprimés.
% echo '010000: 41' | xxd -r -s -0x10000 > fichier

Utiliser xxd comme filtre dans un éditeur tel que vim(1) pour convertir une zone comprise entre les marques 'a' et 'z'.
:'a,'z!xxd

Utiliser xxd comme filtre dans un éditeur tel que vim(1) pour récupérer une conversion binaire comprise entre les marques 'a' et 'z'.
:'a,'z!xxd -r

Utiliser xxd comme filtre dans un éditeur tel que vim(1) pour récupérer une ligne convertie. Placez le curseur sur la ligne et tapez :
!!xxd -r

Lire des caractères depuis une connexion série :
% xxd -c1 < /dev/term/b &
% stty < /dev/term/b -echo -opost -isig -icanon min 1
% echo -n foo > /dev/term/b

VALEURS DE RETOUR
Les erreurs suivantes sont rapportées :

0   aucune erreur ne s'est produit.

-1  opération non supportée ( xxd -r -i reste impossible).

1   erreur lors de l'analyse des options.

2   problème avec le fichier d'entrée.

3   problème avec le fichier de sortie.

4, 5
    la position spécifiée n'est pas atteignable.

VOIR AUSSI
uuencode(1), uudecode(1), patch(1)

AVERTISSEMENTS
L'étrangeté de cet outil reflète celle du cerveau de ses créateurs. Utilisez cet outil à vos risques et périls. Dupliquez vos fichiers. Surveillez l'outil. Devenez un gourou.

VERSION
Cette page de manuel documente la version 1.7 de xxd.

AUTEUR
(c) 1990-1997 par Juergen Weigert
<jnweiger@informatik.uni-erlangen.de>

"Distribute freely and credit me,
make money and share with me,
lose money and don't ask me."

Distribution libre en citant l'auteur,
gagnez de l'argent, pensez à moi,
perdez de l'argent, oubliez-moi.

Page de manuel débutée par Tony Nugent
<tony@sctnugen.ppp.gu.edu.au> <T.Nugent@sct.gu.edu.au>
Modifications mineures par Bram Moolenaar. Édité par Juergen Weigert.

TRADUCTION
Cette page de manuel a été traduite par David Blanchet <david.blanchet@free.fr> 2004-12-24. Mise à jour 2013-05-10, Dominique Pellé <dominique.pelle@gmail.com>